// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:wyatt_authentication_bloc/src/form/form_input.dart';
import 'package:wyatt_authentication_bloc/src/form/form_input_status.dart';
import 'package:wyatt_authentication_bloc/src/form/form_status.dart';

/// Class which contains methods that help manipulate and manage
/// [FormStatus] and [FormInputStatus] instances.
class FormValidator {
  /// Returns a [FormStatus] given a list of [FormInput].
  static FormStatus validate(List<FormInput> inputs) {
    return inputs.every((FormInput element) => element.pure)
        ? FormStatus.pure
        : inputs.any((FormInput input) => input.valid == false)
            ? FormStatus.invalid
            : FormStatus.valid;
  }
}
